// $Id: UnwantedMessage.cs 712730 2008-07-29 06:31:55Z jadixson $
// 
// Copyright 2007-2008 Cisco Systems Inc.
// 
// Licensed under the Apache License, Version 2.0 (the "License"); you may not
// use this file except in compliance with the License. You may obtain a copy
// of the License at
//  
//     http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS, WITHOUT
// WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the
// License for the specific language governing permissions and limitations
// under the License.

using System;
using Etch.Msg;
using Etch.Util;

namespace Etch.Transport
{
    /// <summary>
    /// Event class used with SessionNotify to report unwanted messages.
    /// </summary>
    public class UnwantedMessage
    {
        public UnwantedMessage(Who sender, Message msg)
        {
            this.sender = sender;
            this.msg = msg;
        }

        public readonly Who sender;

        public readonly Message msg;

        public override String ToString()
        {
            return String.Format("Unwanted message from %s: %s", sender, msg);
        }
    }
}
